//  MFC Tv \[X R[hł́AMFC Microsoft Office Fluent [U[ C^[tFCX 
// ("Fluent UI") ̎gp@܂B̃R[h́AMFC C++ Cu \tgEFA 
// Ă Microsoft Foundation Class t@Xъ֘AdqhLg
// ⊮邽߂̎QlƂĒ񋟂܂B
// Fluent UI 𕡐AgpA܂͔zz邽߂̃CZX͌ʂɗpӂĂ܂B
// Fluent UI CZX vȌڍׂɂẮAWeb TCg
// http://msdn.microsoft.com/officeui QƂĂB
//
// Copyright (C) Microsoft Corporation
// All rights reserved.

// BonTestDoc.cpp : CBonTestDoc NX̎
//

#include "stdafx.h"
#include "BonTestUI.h"
#include "MainFrm.h"
#include "BonTestDoc.h"
#include "BonTestView.h"

// C++ TR1֘A
#include <regex>		/* K\(namespace std::tr1) */

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CBonTestDoc

IMPLEMENT_DYNCREATE(CBonTestDoc, CDocument)

BEGIN_MESSAGE_MAP(CBonTestDoc, CDocument)
	ON_COMMAND(ID_RIBBON_TUNER, &CBonTestDoc::OnTuner)
	ON_COMMAND(ID_RIBBON_CHANNEL, &CBonTestDoc::OnChannel)
	ON_COMMAND(ID_RIBBON_SERVICE_NAME_LIST, &CBonTestDoc::OnService)
	ON_COMMAND_RANGE(ID_RIBBON_ITEM_START, ID_RIBBON_ITEM_END, OnDummy)
	ON_COMMAND(ID_DTV_BONTSENGINE_RESET, &CBonTestDoc::OnDtvBontsengineReset)
	ON_COMMAND(ID_DTV_VIDEO_DECODER, &CBonTestDoc::OnDtvVideoDecoder)
	ON_COMMAND(ID_DTV_VIDEO_RENDERER, &CBonTestDoc::OnDtvVideoRenderer)
END_MESSAGE_MAP()


// CBonTestDoc RXgNV/fXgNV

CBonTestDoc::CBonTestDoc()
	: m_ePlayMode(PlayMode_Closing)
	, m_ErrorString()
	, m_hDrvLib(NULL)
	, m_byTuner(0)
	, m_wChannel(0)
	, m_eAudioOutputMode(CMainFrame::AudioOutputMode_Throw)
	, m_eVideoAspectRatioMode(CMainFrame::VideoAspectRatioMode_Auto)
	, m_bFullScreen(FALSE)
	, m_lMainFrame_StyleSave(0)
	, m_lView_ExStyleSave(0)
	, m_rcMainFrame_RectSave()
{
	// TODO: ̈ʒu 1 xĂ΂\zp̃R[hǉĂB
}

CBonTestDoc::~CBonTestDoc()
{
	OnClose();
}

BOOL CBonTestDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	// JĂΕ
	OnClose();

	// R[h
	m_ePlayMode = PlayMode_Closing;
	m_ErrorString.Empty();
	m_byTuner = 0;
	m_wChannel = 0;

	CString sBonDriver;
	if(theApp.GetCommandLineInfo().IsDriverSelect())
	{
		OnOpen(PlayMode_File,theApp.GetCommandLineInfo().GetDriverPath());
	} else {
		OnOpen(PlayMode_BonDriver,_T("BonDriver.dll"));
	}

	return TRUE;
}

// CBonTestDoc VA

void CBonTestDoc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
		// TODO: i[R[hɒǉĂB
	}
	else
	{
		// TODO: ǂݍރR[hɒǉĂB
	}
}


// CBonTestDoc ff

#ifdef _DEBUG
void CBonTestDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CBonTestDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG


// CBonTestDoc R}h
BOOL CBonTestDoc::OnOpenDocument(LPCTSTR lpszPathName)
{
	// Serializeœǂݍ݂sȂIWȉp
//	if(!CDocument::OnOpenDocument(lpszPathName))
//		return FALSE;

	if(!OnOpen(PlayMode_File,lpszPathName))
		return FALSE;

	return TRUE;
}

// ŏ̃r[Ԃ
CView* CBonTestDoc::GetFirstView()
{
	// QƂȂ̂łPsɂłȂ
	POSITION pos = GetFirstViewPosition();	
	if(pos!=NULL)
	{
		return GetNextView(pos);
	}
	return NULL;
}

// J(Document-View  1:1Ȃ̂OB)
bool CBonTestDoc::OnOpen(enum PlayMode ePlayMode, LPCTSTR lpszFileName)
{
	CMainFrame *pWnd = GetMainFrame();

	LPTSTR lpszName = PathFindFileName(lpszFileName);
	LPTSTR lpszExt = PathFindExtension(lpszFileName);
	if(lpszExt && lpszExt[0]==_T('.')) lpszExt++;

	// BonDriver𔻕ʁBWindows\Lł BonDriver*.dll𐳋K\Ń`FbN
	std::tr1::basic_regex<TCHAR> regex_bondriver_dll(
		_T("BonDriver.*\\.dll"),
		std::tr1::basic_regex<TCHAR>::icase);

	// JĂȂ
	OnClose();

	// r[擾Ă(SDI)
	CBonTestView *pView = reinterpret_cast<CBonTestView*>(GetFirstView());
	if(pView)
	{
		if(!pView->IsKindOf(RUNTIME_CLASS(CBonTestView)))
		{
			pView=NULL;
		}
	}
	if(!pView)
	{
		// ̃pX͂Ȃ
		m_ErrorString = _T("I[vView܂쐬Ă܂łB");
		m_ePlayMode = PlayMode_Error;
		return false;
	}

	// BonDriver
	CString sErrMsg;
	try {
		// DTVGW\z
		if(!m_DtvEngine.IsEngineBuild())
		{
			bool bDescramble = theApp.GetCommandLineInfo().IsNotDescramble();
			enum CMediaViewer::PriorityVideoDecoder eMpeg2Dec = theApp.GetCommandLineInfo().GetPriorityVideoDecoder();
			enum CDirectShowUtil::RendererType eRendererType = theApp.GetCommandLineInfo().GetVideooRendererType();
			if(!m_DtvEngine.BuildEngine(this, pView->GetSafeHwnd(),pView->GetSafeHwnd()
				,!bDescramble,eMpeg2Dec,eRendererType
				))
			{
				sErrMsg.Format(_T("BonTsEngine\zɎs܂B\n>>%s"),m_DtvEngine.GetLastErrorString());
				throw (LPCTSTR)sErrMsg;
			} else {			
				if(!pWnd->OnSendAllOption(CMainFrame::SendOption_All,this))
				{
					sErrMsg.Format(_T("CMainFrame ւBonTsEngine\zʒms܂B"));
					throw (LPCTSTR)sErrMsg;
				}				
			}
			// Oɕ\
			wchar_t wszName[128];
			pWnd->LogPrintf(_T("BonTsEngine \zB"));
			if(m_DtvEngine.GetVideoDecorderName(wszName,128))
			{
				pWnd->LogPrintf(_T("ffR[_ : %s"),wszName);
			}
			if(m_DtvEngine.GetVideoRendererName(wszName,128))
			{
				pWnd->LogPrintf(_T("f_ : %s"),wszName);
			}
		}

		// ɏ]J
		if(ePlayMode==PlayMode_BonDriver || std::tr1::regex_match(lpszName,regex_bondriver_dll))
		{
			m_hDrvLib = LoadLibrary(lpszFileName);
			if(!m_hDrvLib)
			{
				sErrMsg.Format(_T("BonDriver̃I[vł܂łB\n%s"),lpszFileName);
				throw (LPCTSTR)sErrMsg;
			}
			pWnd->LogPrintf(_T("BonDriver : %s Open"),lpszFileName);

			if(!m_DtvEngine.OpenSrcFilter_BonDriver(m_hDrvLib))
			{
				sErrMsg.Format(_T("BonDriveȑɎs܂B"));
				throw (LPCTSTR)sErrMsg;
			}
			pWnd->LogPrintf(_T("BonDriver : %s OK"),lpszFileName);

			// XgXV
			if(m_DtvEngine.m_BonSrcDecoder.IsBonDriver2())
			{
				pWnd->LogPrintf(_T("IBonDriver2 Interface"),lpszFileName);
				// IBonDriver2̏ꍇ̂
				m_byTuner = 0;
				m_wChannel = 0;
				CStringArray *pTunerList = new CStringArray;
				CStringArray *pChannelList = new CStringArray;
				for(DWORD dwSpace = 0UL ; m_DtvEngine.m_BonSrcDecoder.GetSpaceName(dwSpace) ; dwSpace++)
				{
					pTunerList->Add(m_DtvEngine.m_BonSrcDecoder.GetSpaceName(dwSpace));
				}
				pWnd->SetTunerList(pTunerList);
				for(DWORD dwSpace = 0UL ; m_DtvEngine.m_BonSrcDecoder.GetChannelName(m_byTuner,dwSpace) ; dwSpace++)
				{
					pChannelList->Add(m_DtvEngine.m_BonSrcDecoder.GetChannelName(m_byTuner,dwSpace));
				}
				pWnd->SetChannelList(pChannelList);
				m_DtvEngine.SetChannel(m_byTuner,m_wChannel);
			} else {
				pWnd->LogPrintf(_T("IBonDriver Interface"),lpszFileName);
				// BonDriveȑꍇ̓`l؂ւT|[g͂Ȃ
				CStringArray *pTunerList = new CStringArray;
				CStringArray *pChannelList = new CStringArray;
				pWnd->SetTunerList(pTunerList);
				pWnd->SetChannelList(pChannelList);				
			}
			m_ePlayMode = PlayMode_BonDriver;
		}
		else if(ePlayMode==PlayMode_File)
		{
			// t@CĐ
			if(!m_DtvEngine.OpenSrcFilter_File(lpszFileName))
			{
				sErrMsg.Format(_T("t@C̃I[vł܂łB\n%s"),lpszFileName);
				throw (LPCTSTR)sErrMsg;
			}
			pWnd->LogPrintf(_T("File : %s Open"),lpszFileName);
			CStringArray *pTunerList = new CStringArray;
			CStringArray *pChannelList = new CStringArray;
			pTunerList->Add(_T("t@C"));
			pWnd->SetTunerList(pTunerList);
			pChannelList->Add(_T("Ȃ"));
			pWnd->SetChannelList(pChannelList);		
			m_ePlayMode = PlayMode_File;
		}
		if(ePlayMode==m_ePlayMode)
		{
			// vr[Jn
			if(!m_DtvEngine.EnablePreview())
			{
				sErrMsg.Format(_T("vr[JnɎs܂B"));
				throw (LPCTSTR)sErrMsg;
			} else {
				pWnd->LogPrintf(_T("vr[Jn"),lpszFileName);
			}
		}
	}
	catch (LPCTSTR lpszErrMsg) {
		pWnd->LogPrintf(lpszErrMsg);
		if(lpszErrMsg)
		{
			AfxMessageBox(lpszErrMsg);
			m_ErrorString = lpszErrMsg;
		} else {
			m_ErrorString = _T("ERROR!");
		}
		OnClose();
		m_ePlayMode = PlayMode_Error;
	}		

	// ʍĕ`
	pView->Invalidate();
	return true;
}

// 
void CBonTestDoc::OnClose(BOOL bDestroyTsEngine)
{
	m_DtvEngine.ReleaseSrcFilter();
	m_DtvEngine.EnablePreview(false);
	if(m_hDrvLib)
	{
		FreeLibrary(m_hDrvLib);
		m_hDrvLib = NULL;
	}
	if(bDestroyTsEngine)
	{
		m_DtvEngine.CloseEngine();
	}

	m_ePlayMode = PlayMode_Closing;
}

const DWORD CBonTestDoc::OnDtvEngineEvent(CDtvEngine *pEngine, const DWORD dwEventID, PVOID pParam)
{
	// SɎb
	CProgManager *pProgManager = static_cast<CProgManager *>(pParam);
	

	switch(dwEventID)
	{
	case CDtvEngine::EID_SERVICE_INFO_UPDATED:
	case CDtvEngine::EID_SERVICE_LIST_UPDATED:
		{
			CMainFrame *pWnd = GetMainFrame();
			if(pWnd)
			{
				CStringArray *pServiceNameList = new CStringArray();
				TCHAR szServiceName[1024];	
				WORD wServiceID;
				pWnd->LogPrintf(_T("T[rXXV"));
				for(WORD wIndex = 0U ; wIndex < pProgManager->GetServiceNum() ; wIndex++)
				{
					if(pProgManager->GetServiceName(szServiceName, wIndex)
						&& pProgManager->GetServiceID(&wServiceID, wIndex) )
					{						
						CString tmp;
						tmp.Format(_T("%d : %s"), wServiceID , szServiceName);
						pServiceNameList->Add(tmp);
						pWnd->LogPrintf(tmp);
					} else{
						CString tmp(_T("T[rX擾..."));
						pServiceNameList->Add(tmp);
						pWnd->LogPrintf(tmp);
					}					
				}
				pWnd->SetServiceList(pServiceNameList);
			}
		}
		break;
	case CDtvEngine::EID_PCR_TIMESTAMP_UPDATED:
		{
			// ̃CxgEKv͂قƂǂȂB
			// ST[rXPCR^CX^vQƂꍇ݂̂Ƃ΂悢B
			for(WORD wIndex = 0U ; wIndex < pProgManager->GetServiceNum() ; wIndex++)
			{
				unsigned __int64 u64TimeStamp;
				if(pProgManager->GetPcrTimeStamp(&u64TimeStamp,wIndex))
				{
#ifdef _DEBUG		
					/*
					unsigned __int64 t = u64TimeStamp / (90 * 1000); // 90kHz
					unsigned __int64 ms= (u64TimeStamp % (90 * 1000)) / 1000;
					unsigned __int64 h = t / (60 * 60);
					unsigned __int64 m = (t - (h * 60 * 60)) / 60;
					unsigned __int64 s = (t - (h * 60 * 60) - (m * 60));					
					TRACE(_T("Service = 0x%02X , sec = %02I64d:%02I64d:%02I64d.%02I64d \n"), wIndex , h , m , s , ms);
					*/
#endif
				}
			}
		}
		break;
	}
	return 0UL;
}

// `[i[IύXꂽ
void CBonTestDoc::OnTuner()
{
	CMainFrame *pWnd = GetMainFrame();
	int iSelect = pWnd->GetTunerSelect();
	if(pWnd&&iSelect!=-1)
	{
		m_byTuner = (BYTE)iSelect;
		m_wChannel = 0;
		if(m_DtvEngine.m_BonSrcDecoder.IsBonDriver2())
		{
			CStringArray *pChannelList = new CStringArray;
			for(DWORD dwSpace = 0UL ; m_DtvEngine.m_BonSrcDecoder.GetChannelName(m_byTuner,dwSpace) ; dwSpace++)
			{
				pChannelList->Add(m_DtvEngine.m_BonSrcDecoder.GetChannelName(m_byTuner,dwSpace));
			}
			pWnd->SetChannelList(pChannelList);
		}
		m_DtvEngine.SetChannel(m_byTuner,m_wChannel);
	}
}

// `lIύXꂽ
void CBonTestDoc::OnChannel()
{
	CMainFrame *pWnd = GetMainFrame();
	int iSelect = pWnd->GetChannelSelect();
	if(pWnd&&iSelect!=-1)
	{
		m_wChannel = (WORD)iSelect;
		m_DtvEngine.SetChannel(m_byTuner,m_wChannel);
	}
}

// T[rXIύXꂽ
void CBonTestDoc::OnService()
{
	CMainFrame *pWnd = GetMainFrame();
	int iSelect = pWnd->GetServiceSelect();
	if(pWnd&&iSelect!=-1)
	{
		m_DtvEngine.SetService((WORD)iSelect);
	}
}

// o͂ύXꂽ(0 - 1000)
void CBonTestDoc::OnAudioVolume(BOOL bEnable,int iVolume)
{
	float fVolume = ((float)(iVolume - 1000)) / 10;
	if(!bEnable)
	{
		fVolume = -100;
	}
	// (Min)-100.00dB - 0.00dB(Max)
	m_DtvEngine.SetVolume(fVolume);

}

// I[fBIo̓[hύXꂽ
void CBonTestDoc::OnAudioOutputMode(CMainFrame::AudioOutputMode eMode)
{
	int iMode = -1;
	m_eAudioOutputMode = eMode;
	switch(eMode)
	{
	case CMainFrame::AudioOutputMode_Throw:
		iMode = 0;
		break;
	case CMainFrame::AudioOutputMode_LeftOnly:
		iMode = 1;
		break;
	case CMainFrame::AudioOutputMode_RightOnly:
		iMode = 2;
		break;
	}
	if(iMode!=-1)
	{
		m_DtvEngine.SetStereoMode(iMode);
	}
}

// rfIAXyNg䃂[hύXꂽ
void CBonTestDoc::OnVideoAspectRatioMode(CMainFrame::VideoAspectRatioMode eMode)
{
	m_eVideoAspectRatioMode = eMode;
	switch(eMode)
	{
	case CMainFrame::VideoAspectRatioMode_Auto:
		m_DtvEngine.SetForceAspectRatio();
		break;
	case CMainFrame::VideoAspectRatioMode_16_9:
		m_DtvEngine.SetForceAspectRatio(16,9);
		break;
	case CMainFrame::VideoAspectRatioMode_4_3:
		m_DtvEngine.SetForceAspectRatio(4,3);
		break;
	case CMainFrame::VideoAspectRatioMode_Disabled:
		m_DtvEngine.SetForceAspectRatio(-1,-1);
		break;
	}
}

// tXN[؂ւ
void CBonTestDoc::OnSwitchFullScreen()
{
//	m_DtvEngine.SwitchFullscreen();
	CMainFrame *pMainFrm = GetMainFrame();
	CBonTestView *pView = reinterpret_cast<CBonTestView*>(GetFirstView());	
	if(pMainFrm && pView && pView->IsKindOf(RUNTIME_CLASS(CBonTestView)))
	{
		HWND hWnd = pMainFrm->GetSafeHwnd();
		HWND hView= pView->GetSafeHwnd();
		int cx,cy;
		if(!m_bFullScreen)
		{
			DWORD dwStyle;
			pMainFrm->HideRibbon();
			// MainFrame
			dwStyle = GetWindowLong(hWnd,GWL_STYLE);
			m_lMainFrame_StyleSave = dwStyle;
			ERASE_FLAG(dwStyle,WS_CAPTION);
			ERASE_FLAG(dwStyle,WS_THICKFRAME);
			SetWindowLong(hWnd,GWL_STYLE,dwStyle);
			GetWindowRect(hWnd,&m_rcMainFrame_RectSave);
			// View
			m_lView_ExStyleSave = dwStyle = GetWindowLong(hView,GWL_EXSTYLE);
			ERASE_FLAG(dwStyle,WS_EX_CLIENTEDGE);
			SetWindowLong(hView,GWL_EXSTYLE,dwStyle);
			// Size
			cx = GetSystemMetrics(SM_CXSCREEN);
			cy = GetSystemMetrics(SM_CYSCREEN);
			MoveWindow(hWnd,0,0,cx,cy,TRUE);
			m_bFullScreen = true;
		} else {			
			pMainFrm->ShowRibbon();
			cx = m_rcMainFrame_RectSave.right-m_rcMainFrame_RectSave.left;
			cy = m_rcMainFrame_RectSave.bottom-m_rcMainFrame_RectSave.top;
			MoveWindow(hWnd,m_rcMainFrame_RectSave.left,m_rcMainFrame_RectSave.top,cx,cy,TRUE);
			SetWindowLong(hView,GWL_EXSTYLE,m_lView_ExStyleSave);
			SetWindowLong(hWnd,GWL_STYLE,m_lMainFrame_StyleSave);
			m_bFullScreen = false;
		}
	}
}

// GW̃Zbg
void CBonTestDoc::OnDtvBontsengineReset()
{
	m_DtvEngine.ResetEngine();
}

// Xe[^Xo[̍XV
void CBonTestDoc::UpdateStatusBar()
{
	CMainFrame *pWnd = GetMainFrame();
	if(!pWnd) return;

	CString str;

	if(1) str.AppendFormat(_T(" %lu "), m_DtvEngine.m_TsPacketParser.GetInputPacketCount());
//	if(1) str.AppendFormat(_T("óF %lu "), m_DtvEngine.m_TsPacketParser.GetOutputPacketCount());
	if(1) str.AppendFormat(_T("G[F%lu "), m_DtvEngine.m_TsPacketParser.GetErrorPacketCount());
	if(1)
	{
		unsigned __int64 u64TimeStamp = m_DtvEngine.GetPcrTimeStamp();
		unsigned __int64 t = u64TimeStamp / (90 * 1000); // 90kHz
		unsigned __int64 ms= (u64TimeStamp % (90 * 1000)) / 1000;
		unsigned __int64 h = t / (60 * 60);
		unsigned __int64 m = (t - (h * 60 * 60)) / 60;
		unsigned __int64 s = (t - (h * 60 * 60) - (m * 60));

		str.AppendFormat(_T("PCR %02I64u:%02I64u:%02I64u:%02I64u "), h , m , s , ms);
	}

	BYTE byX,byY;
	WORD wX,wY;
	if(m_DtvEngine.GetVideoSize(&wX,&wY))
	{
		wchar_t szName[80];		
		str.AppendFormat(_T("fF %dx%d "), wX , wY);

		if(m_DtvEngine.GetVideoAspectRatio(&byX,&byY))
		{
			str.AppendFormat(_T("(%d:%d) "), byX , byY);				
		}
		if(m_DtvEngine.GetVideoDecorderName(szName,80))
		{
			str.AppendFormat(_T(" [%s] "),szName);
		}
		if(m_DtvEngine.GetVideoRendererName(szName,80))
		{
			str.AppendFormat(_T(" [%s] "),szName);
		}
	}
	BYTE byAudioChannel = m_DtvEngine.GetAudioCahnnelNum();
	if(byAudioChannel>0){
		str.AppendFormat(_T(" : "));
		// ݂͓񃖍EύX͍lĂȂ(ȂEITȂƂȂ)
//		if(m_byCurAudioChannel != byAudioChannel)
//		{
//			// `lωꍇA[hX[ɂ
//		}		
		switch(byAudioChannel){
		case 1:
			str.AppendFormat(_T("m"));
			break;
		case 2:
			switch(m_eAudioOutputMode){
		case CMainFrame::AudioOutputMode_LeftOnly:
				str.AppendFormat(_T("XeI()"));
				break;
		case CMainFrame::AudioOutputMode_RightOnly:
				str.AppendFormat(_T("XeI(E)"));
				break;
			default:
				str.AppendFormat(_T("XeI"));
				break;
			}
			break;
		case 6:
			str.AppendFormat(_T("5.1ch(2ch_E~NX)"));
			break;
		default:
			str.AppendFormat(_T("%dch"),byAudioChannel);
			break;
		}
	}

	// Xe[^Xo[ɃZbg
	pWnd->SetStatusBarText(str);
}
void CBonTestDoc::OnDtvVideoDecoder()
{
	if(m_DtvEngine.IsEngineBuild())
	{
		m_DtvEngine.DisplayVideoDecorderProperty(GetMainFrame()->GetSafeHwnd());
	}
}

void CBonTestDoc::OnDtvVideoRenderer()
{
	if(m_DtvEngine.IsEngineBuild())
	{
		m_DtvEngine.DisplayVideoRendererProperty(GetMainFrame()->GetSafeHwnd());
	}
}
