//  MFC Tv \[X R[hł́AMFC Microsoft Office Fluent [U[ C^[tFCX 
// ("Fluent UI") ̎gp@܂B̃R[h́AMFC C++ Cu \tgEFA 
// Ă Microsoft Foundation Class t@Xъ֘AdqhLg
// ⊮邽߂̎QlƂĒ񋟂܂B
// Fluent UI 𕡐AgpA܂͔zz邽߂̃CZX͌ʂɗpӂĂ܂B
// Fluent UI CZX vȌڍׂɂẮAWeb TCg
// http://msdn.microsoft.com/officeui QƂĂB
//
// Copyright (C) Microsoft Corporation
// All rights reserved.

// BonTestDoc.h : CBonTestDoc NX̃C^[tFCX
//

#pragma once

#include "DtvEngine.h"

class CBonTestDoc : public CDocument , public CDtvEngineHandler
{
protected: // VÂݍ쐬܂B
	CBonTestDoc();
	DECLARE_DYNCREATE(CBonTestDoc)

// 
public:

// 
public:

// I[o[Ch
public:
	virtual BOOL OnNewDocument();
	virtual void Serialize(CArchive& ar);

// 
public:
	virtual ~CBonTestDoc();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// ꂽAbZ[W蓖Ċ֐
protected:
	DECLARE_MESSAGE_MAP()

public:
	enum PlayMode
	{
		PlayMode_Closing = 0 , PlayMode_BonDriver , PlayMode_File , PlayMode_Error=-1
	};
	static CMainFrame* GetMainFrame(void)
	{
		return dynamic_cast<CMainFrame*>(theApp.GetMainWnd());
	}
	enum PlayMode GetCurrentPlayMode() { return m_ePlayMode; }
	LPCTSTR GetErrorMessage() { return m_ErrorString; };
	float GetSignalLevel()
	{
		return m_DtvEngine.m_BonSrcDecoder.GetSignalLevel();
	}
	void SetVideoViewSize(int cx,int cy)
	{
		m_DtvEngine.SetViewSize(cx,cy);
	}
	void UpdateStatusBar();

protected:
	virtual BOOL OnOpenDocument(LPCTSTR lpszPathName);
	PlayMode m_ePlayMode;
	CString m_ErrorString;
	BYTE m_byTuner;
	WORD m_wChannel;
	CMainFrame::AudioOutputMode m_eAudioOutputMode;
	CMainFrame::VideoAspectRatioMode m_eVideoAspectRatioMode;

	HMODULE m_hDrvLib;
	CDtvEngine m_DtvEngine;
	CView* GetFirstView();
	bool OnOpen(enum PlayMode ePlayMode, LPCTSTR lpszFileName);
public:
	void OnClose(BOOL bDestroyTsEngine=FALSE);
	void OnAudioVolume(BOOL bEnable,int iVolume);	
	void OnAudioOutputMode(CMainFrame::AudioOutputMode eMode);
	void OnVideoAspectRatioMode(CMainFrame::VideoAspectRatioMode eMode);
	void OnSwitchFullScreen();
protected:
	bool m_bFullScreen;
	LONG m_lMainFrame_StyleSave;
	LONG m_lView_ExStyleSave;
	RECT m_rcMainFrame_RectSave;
	const DWORD OnDtvEngineEvent(CDtvEngine *pEngine, const DWORD dwEventID, PVOID pParam);

public:
	afx_msg void OnDummy(UINT /*id*/){}
	afx_msg void OnTuner();
	afx_msg void OnChannel();
	afx_msg void OnService();
	afx_msg void OnDtvBontsengineReset();
	afx_msg void OnDtvVideoDecoder();
	afx_msg void OnDtvVideoRenderer();
};
