//  MFC Tv \[X R[hł́AMFC Microsoft Office Fluent [U[ C^[tFCX 
// ("Fluent UI") ̎gp@܂B̃R[h́AMFC C++ Cu \tgEFA 
// Ă Microsoft Foundation Class t@Xъ֘AdqhLg
// ⊮邽߂̎QlƂĒ񋟂܂B
// Fluent UI 𕡐AgpA܂͔zz邽߂̃CZX͌ʂɗpӂĂ܂B
// Fluent UI CZX vȌڍׂɂẮAWeb TCg
// http://msdn.microsoft.com/officeui QƂĂB
//
// Copyright (C) Microsoft Corporation
// All rights reserved.

// MainFrm.h : CMainFrame NX̃C^[tFCX
//

#pragma once

#include "OutputWnd.h"
#include "PlayerPosWnd.h"

class CMainFrame : public CFrameWndEx
{
	
protected: // VÂݍ쐬܂B
	CMainFrame();
	DECLARE_DYNCREATE(CMainFrame)

// 
public:

// 
public:

// I[o[Ch
public:
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);

// 
public:
	virtual ~CMainFrame();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

	enum VideoAspectRatioMode
	{
		VideoAspectRatioMode_Disabled = 0,
		VideoAspectRatioMode_Auto,
		VideoAspectRatioMode_16_9,
		VideoAspectRatioMode_4_3
	};
	enum AudioOutputMode
	{
		AudioOutputMode_Throw = 0,
		AudioOutputMode_LeftOnly,
		AudioOutputMode_RightOnly
	};

		CMFCRibbonBar     m_wndRibbonBar;

protected:  // Rg[ o[po	
	CMFCRibbonApplicationButton m_MainButton;
	CMFCToolBarImages m_PanelImages;
	CMFCRibbonStatusBar  m_wndStatusBar;
	COutputWnd	m_dockOutput;
	CPlayerPosWnd m_dockPlayerPos;
	BOOL m_bDockOutputVisible;
	BOOL m_bDockPlayerPosVisible;

	VideoAspectRatioMode m_eVideoAspectRatioMode;
	BOOL m_bAudioOutputEnable;
	AudioOutputMode m_eAudioOutputMode;
	int m_iAudioVolumeMin;
	int m_iAudioVolumeMax;
	int m_iAudioVolume;
	struct {
		struct RibbonItem {
			CMFCRibbonComboBox	*pTuner;
			CMFCRibbonComboBox	*pChannel;
			CMFCRibbonLabel		*pRecieveLevel;
		} BonDriver;
		struct {
			CMFCRibbonComboBox *pService;
			CMFCRibbonButton *pAudioEnable;
			CMFCRibbonSlider *pAudioSlider;
		} DTV;
	} m_RibbonItem;
	BOOL m_bUIReady;

// ꂽAbZ[W蓖Ċ֐
protected:
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnApplicationLook(UINT id);
	afx_msg void OnUpdateApplicationLook(CCmdUI* pCmdUI);
	DECLARE_MESSAGE_MAP()
	
	// {֌WȂ肪Ȃ̂ŕށA
	BOOL InitializeRibbon();
	BOOL InitializeRibbon_MainButton();
	BOOL InitializeRibbon_Home();
	BOOL InitializeRibbon_Record();
	BOOL InitializeRibbon_View();
	BOOL InitializeRibbon_VisualStyle();
	BOOL InitializeRibbon_Help();
	BOOL InitializeRibbon_QuickAccessToolbar();
	BOOL InitializeRibbon_Statusbar();
	BOOL InitializeRibbon_Docking();

public:
	// {o[ɕ\Mxݒ肷
	void SetSignalLevel(float fSignalLevel);
	void SetStatusBarText(LPCTSTR lpszText,int iPane = 0);
	afx_msg void OnDestroy();

	UINT m_uRibbonItemUpdate;
	void SetTunerList(CStringArray *pTunerList);
	void SetChannelList(CStringArray *pChannelList);
	void SetServiceList(CStringArray *pServiceList);
	int GetTunerSelect();
	int GetChannelSelect();
	int GetServiceSelect();

protected:
	virtual LRESULT WindowProc(UINT message, WPARAM wParam, LPARAM lParam);

public:
	enum SendOptionFlg {
		SendOption_None		= 0,
		SendOption_Video	= 0x00000001,
		SendOption_Audio	= 0x00010000,
		SendOption_All		= 0xFFFFFFFF
	};
	void LogPrintf(LPCTSTR format,...);
	bool OnSendAllOption(SendOptionFlg eFlg=SendOption_All,CDocument *pTargetDocument=NULL);	
	void ReSendOnSize();
	void ShowRibbon();
	void HideRibbon();
	afx_msg void OnAspectratioAuto();
	afx_msg void OnAspectratio16_9();
	afx_msg void OnAspectratio4_3();
	afx_msg void OnAspectratioDisabled();
	afx_msg void OnUpdateAspectratioAuto(CCmdUI *pCmdUI);
	afx_msg void OnUpdateAspectratio16_9(CCmdUI *pCmdUI);
	afx_msg void OnUpdateAspectratio4_3(CCmdUI *pCmdUI);
	afx_msg void OnUpdateAspectratioDisabled(CCmdUI *pCmdUI);
	afx_msg void OnAudioEnable();
	afx_msg void OnUpdateAudioEnable(CCmdUI *pCmdUI);
	afx_msg void OnAudioVolume();
	afx_msg void OnAudioOutputThrow();
	afx_msg void OnAudioOutputLeftOnly();
	afx_msg void OnAudioOutputRightOnly();
	afx_msg void OnUpdateAudioOutputThrow(CCmdUI *pCmdUI);
	afx_msg void OnUpdateAudioOutputLeftOnly(CCmdUI *pCmdUI);
	afx_msg void OnUpdateAudioOutputRightOnly(CCmdUI *pCmdUI);
	afx_msg void OnDockOutput();
	afx_msg void OnUpdateDockOutput(CCmdUI *pCmdUI);
	afx_msg void OnDockPlayerPos();
	afx_msg void OnUpdateDockPlayerPos(CCmdUI *pCmdUI);
};


