//  MFC Tv \[X R[hł́AMFC Microsoft Office Fluent [U[ C^[tFCX 
// ("Fluent UI") ̎gp@܂B̃R[h́AMFC C++ Cu \tgEFA 
// Ă Microsoft Foundation Class t@Xъ֘AdqhLg
// ⊮邽߂̎QlƂĒ񋟂܂B
// Fluent UI 𕡐AgpA܂͔zz邽߂̃CZX͌ʂɗpӂĂ܂B
// Fluent UI CZX vȌڍׂɂẮAWeb TCg
// http://msdn.microsoft.com/officeui QƂĂB
//
// Copyright (C) Microsoft Corporation
// All rights reserved.

// BonTestView.cpp : CBonTestView NX̎
//

#include "stdafx.h"
#include "BonTestUI.h"
#include "MainFrm.h"

#include "BonTestDoc.h"
#include "BonTestView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CBonTestView

IMPLEMENT_DYNCREATE(CBonTestView, CView)

BEGIN_MESSAGE_MAP(CBonTestView, CView)
	ON_WM_RBUTTONUP()
	ON_WM_TIMER()
	ON_WM_CREATE()
	ON_WM_SIZE()
	ON_WM_DESTROY()
	ON_WM_LBUTTONDBLCLK()
	ON_WM_KEYDOWN()
END_MESSAGE_MAP()

// CBonTestView RXgNV/fXgNV

CBonTestView::CBonTestView()
{
	// TODO: \zR[hɒǉ܂B

}

CBonTestView::~CBonTestView()
{
}

BOOL CBonTestView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: ̈ʒu CREATESTRUCT cs C Window NX܂̓X^C
	//  CĂB
	cs.lpszClass = AfxRegisterWndClass(
		CS_DBLCLKS,
		AfxGetApp()->LoadStandardCursor(IDC_ARROW),(HBRUSH)GetStockObject(BLACK_BRUSH),
        AfxGetApp()->LoadIcon(IDR_MAINFRAME));

	return CView::PreCreateWindow(cs);
}

// CBonTestView `

void CBonTestView::OnDraw(CDC* pDC)
{
	CBonTestDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	if (!pDoc)
		return;
	
	CRect rectClient;
	GetClientRect (&rectClient);
	if(pDoc->GetCurrentPlayMode() == CBonTestDoc::PlayMode_Error)
	{
		DrawErrorMessage(pDC,pDoc->GetErrorMessage(),rectClient);
	}
}

void CBonTestView::DrawErrorMessage(CDC* pDC,LPCTSTR lpszErrorMsg,CRect &cRect)
{
	const CString strInfo = lpszErrorMsg;
	const int iOffset = 20;

	CFont* pFontOld = (CFont*) pDC->SelectStockObject (DEFAULT_GUI_FONT);
	ASSERT (pFontOld != NULL);
	CRect rectText = cRect;
	rectText.DeflateRect (iOffset, iOffset);
	pDC->DrawText (strInfo, rectText, DT_CALCRECT | DT_WORDBREAK);
	rectText.OffsetRect (	(cRect.Width () - rectText.Width () - 2 * iOffset) / 2,
							(cRect.Height () - rectText.Height () - 2 * iOffset) / 2);
	CRect rectFrame = rectText;
	rectFrame.InflateRect (iOffset, iOffset);
	pDC->FillSolidRect (rectFrame, ::GetSysColor (COLOR_INFOBK));	
	rectFrame.DeflateRect (1, 1);
	pDC->Draw3dRect (rectFrame, ::GetSysColor (COLOR_3DSHADOW), 
					::GetSysColor (COLOR_3DLIGHT));
	rectFrame.DeflateRect (2, 2);
	pDC->Draw3dRect (rectFrame, ::GetSysColor (COLOR_3DSHADOW), 
					::GetSysColor (COLOR_3DLIGHT));
	pDC->SetTextColor (::GetSysColor (COLOR_INFOTEXT));
	pDC->SetBkMode (TRANSPARENT);
	pDC->DrawText (strInfo, rectText, DT_WORDBREAK );
	pDC->SelectObject (pFontOld);
}

void CBonTestView::OnRButtonUp(UINT nFlags, CPoint point)
{
	ClientToScreen(&point);
	OnContextMenu(this, point);
}

void CBonTestView::OnContextMenu(CWnd* pWnd, CPoint point)
{
	theApp.GetContextMenuManager()->ShowPopupMenu(IDR_POPUP_EDIT, point.x, point.y, this, TRUE);
}

// CBonTestView ff

#ifdef _DEBUG
void CBonTestView::AssertValid() const
{
	CView::AssertValid();
}

void CBonTestView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CBonTestDoc* CBonTestView::GetDocument() const // fobOȊÕo[W̓CCłB
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CBonTestDoc)));
	return (CBonTestDoc*)m_pDocument;
}
#endif //_DEBUG


// CBonTestView bZ[W nh

int CBonTestView::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CView::OnCreate(lpCreateStruct) == -1)
		return -1;
	SetTimer(1,500,NULL);
	return 0;
}

void CBonTestView::OnDestroy()
{
	CBonTestDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	if (!pDoc)
		return;
	KillTimer(1);
	CView::OnDestroy();
}

void CBonTestView::OnSize(UINT nType, int cx, int cy)
{	
	CBonTestDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	if (!pDoc)
		return;
	pDoc->SetVideoViewSize(cx,cy);
	CView::OnSize(nType, cx, cy);	
}

void CBonTestView::OnLButtonDblClk(UINT nFlags, CPoint point)
{
	CBonTestDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	if (!pDoc)
		return;
	pDoc->OnSwitchFullScreen();
	CView::OnLButtonDblClk(nFlags, point);
}

void CBonTestView::OnTimer(UINT_PTR nIDEvent)
{
	CBonTestDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	if (!pDoc)
		return;

	// MxXV
	CMainFrame *pWnd = pDoc->GetMainFrame();
	if(pWnd)
	{
		pWnd->SetSignalLevel(pDoc->GetSignalLevel());
	}

	// Xe[^Xo[XV
	pDoc->UpdateStatusBar();
	CView::OnTimer(nIDEvent);
}

void CBonTestView::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags)
{
	CBonTestDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	CMainFrame *pWnd = pDoc->GetMainFrame();	
	ASSERT(pWnd);

	switch(nChar)
	{
	case VK_F5:
		{
			CRect cRect;
			GetClientRect(&cRect);
			pDoc->SetVideoViewSize(cRect.Width(),cRect.Height());
			Invalidate();
		}
		break;
	}

	CView::OnKeyDown(nChar, nRepCnt, nFlags);
}
