//  MFC Tv \[X R[hł́AMFC Microsoft Office Fluent [U[ C^[tFCX 
// ("Fluent UI") ̎gp@܂B̃R[h́AMFC C++ Cu \tgEFA 
// Ă Microsoft Foundation Class t@Xъ֘AdqhLg
// ⊮邽߂̎QlƂĒ񋟂܂B
// Fluent UI 𕡐AgpA܂͔zz邽߂̃CZX͌ʂɗpӂĂ܂B
// Fluent UI CZX vȌڍׂɂẮAWeb TCg
// http://msdn.microsoft.com/officeui QƂĂB
//
// Copyright (C) Microsoft Corporation
// All rights reserved.

// MainFrm.cpp : CMainFrame NX̎
//

#include "stdafx.h"
#include "BonTestUI.h"

#include "MainFrm.h"
#include "BonTestDoc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// CMainFrame

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWndEx)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWndEx)
	// قƂǎ菑BpRg[hcȂACe̓_~[j[IDg
	// BonDriver֘AAT[rXIDocument̔eȂ̂ŁAɋLq
	ON_WM_CREATE()
	ON_COMMAND_RANGE(ID_VIEW_APPLOOK_WIN_2000, ID_VIEW_APPLOOK_OFF_2007_AQUA, &CMainFrame::OnApplicationLook)
	ON_UPDATE_COMMAND_UI_RANGE(ID_VIEW_APPLOOK_WIN_2000, ID_VIEW_APPLOOK_OFF_2007_AQUA, &CMainFrame::OnUpdateApplicationLook)
	ON_WM_DESTROY()
	ON_COMMAND(ID_ASPECTRATIO_AUTO, &CMainFrame::OnAspectratioAuto)
	ON_COMMAND(ID_ASPECTRATIO_16_9, &CMainFrame::OnAspectratio16_9)
	ON_COMMAND(ID_ASPECTRATIO_4_3, &CMainFrame::OnAspectratio4_3)
	ON_COMMAND(ID_ASPECTRATIO_DISABLED, &CMainFrame::OnAspectratioDisabled)
	ON_UPDATE_COMMAND_UI(ID_ASPECTRATIO_AUTO, &CMainFrame::OnUpdateAspectratioAuto)
	ON_UPDATE_COMMAND_UI(ID_ASPECTRATIO_16_9, &CMainFrame::OnUpdateAspectratio16_9)
	ON_UPDATE_COMMAND_UI(ID_ASPECTRATIO_4_3, &CMainFrame::OnUpdateAspectratio4_3)
	ON_UPDATE_COMMAND_UI(ID_ASPECTRATIO_DISABLED, &CMainFrame::OnUpdateAspectratioDisabled)
	ON_COMMAND(ID_AUDIO_ENABLE, &CMainFrame::OnAudioEnable)
	ON_UPDATE_COMMAND_UI(ID_AUDIO_ENABLE, &CMainFrame::OnUpdateAudioEnable)
	ON_COMMAND(ID_DTV_AUDIO_VOLUME, &CMainFrame::OnAudioVolume)
	ON_COMMAND(ID_AUDIO_THROW, &CMainFrame::OnAudioOutputThrow)
	ON_COMMAND(ID_AUDIO_LEFT_ONLY, &CMainFrame::OnAudioOutputLeftOnly)
	ON_COMMAND(ID_AUDIO_RIGHT_ONLY, &CMainFrame::OnAudioOutputRightOnly)
	ON_UPDATE_COMMAND_UI(ID_AUDIO_THROW, &CMainFrame::OnUpdateAudioOutputThrow)
	ON_UPDATE_COMMAND_UI(ID_AUDIO_LEFT_ONLY, &CMainFrame::OnUpdateAudioOutputLeftOnly)
	ON_UPDATE_COMMAND_UI(ID_AUDIO_RIGHT_ONLY, &CMainFrame::OnUpdateAudioOutputRightOnly)
	ON_COMMAND(ID_DOCK_OUTPUT, &CMainFrame::OnDockOutput)
	ON_UPDATE_COMMAND_UI(ID_DOCK_OUTPUT, &CMainFrame::OnUpdateDockOutput)
	ON_COMMAND(ID_DOCK_PLAYERPOS, &CMainFrame::OnDockPlayerPos)
	ON_UPDATE_COMMAND_UI(ID_DOCK_PLAYERPOS, &CMainFrame::OnUpdateDockPlayerPos)
END_MESSAGE_MAP()

// CMainFrame RXgNV/fXgNV

CMainFrame::CMainFrame()
	:m_bUIReady(FALSE)
	,m_uRibbonItemUpdate(WM_APP)
	, m_eVideoAspectRatioMode(VideoAspectRatioMode_Auto)
	, m_bAudioOutputEnable(TRUE)
	, m_eAudioOutputMode(AudioOutputMode_Throw)
	, m_iAudioVolumeMin(500)
	, m_iAudioVolumeMax(1000)
	, m_iAudioVolume(1000)
	, m_bDockOutputVisible(FALSE)
	, m_bDockPlayerPosVisible(FALSE)
{
	// I쐬{o\̂̏
	ZeroMemory(&m_RibbonItem,sizeof(m_RibbonItem));
	// bZ[W쐬
	m_uRibbonItemUpdate = RegisterWindowMessage(_T("BonTest_RibbonItemUpdateMessage"));
	// WXgǂݍ
	theApp.m_nAppLook = theApp.GetInt(APPREG_APPLICATION_LOOK, ID_VIEW_APPLOOK_OFF_2007_BLUE);
	m_eVideoAspectRatioMode = (VideoAspectRatioMode)theApp.GetInt(APPREG_VIDEO_ASPECT_RATIO_MODE, VideoAspectRatioMode_Auto);
	m_bAudioOutputEnable = (BOOL)theApp.GetInt(APPREG_AUDIO_ENABLE, TRUE);
	m_eAudioOutputMode = (AudioOutputMode)theApp.GetInt(APPREG_AUDIO_OUTPUT_MODE, AudioOutputMode_Throw);
	m_iAudioVolumeMin = max(theApp.GetInt(APPREG_AUDIO_VOLUME_MIN, 500),0);
	m_iAudioVolumeMax = min(theApp.GetInt(APPREG_AUDIO_VOLUME_MAX, 1000),1000);
	m_iAudioVolume = theApp.GetInt(APPREG_AUDIO_VOLUME, 1000);
	m_iAudioVolume = max(min(m_iAudioVolume,m_iAudioVolumeMax),m_iAudioVolumeMin);
	m_bDockOutputVisible = (BOOL)theApp.GetInt(APPREG_OUTPUT_DOCK, FALSE);
	m_bDockPlayerPosVisible = (BOOL)theApp.GetInt(APPREG_PLAYER_DOCK, FALSE);
}

CMainFrame::~CMainFrame()
{
	// WXg
	theApp.WriteInt(APPREG_VIDEO_ASPECT_RATIO_MODE,m_eVideoAspectRatioMode);
	theApp.WriteInt(APPREG_AUDIO_ENABLE,m_bAudioOutputEnable);
	theApp.WriteInt(APPREG_AUDIO_OUTPUT_MODE,m_eAudioOutputMode);
	theApp.WriteInt(APPREG_AUDIO_VOLUME_MIN,m_iAudioVolumeMin);
	theApp.WriteInt(APPREG_AUDIO_VOLUME_MAX,m_iAudioVolumeMax);
	theApp.WriteInt(APPREG_AUDIO_VOLUME,m_iAudioVolume);
	theApp.WriteInt(APPREG_OUTPUT_DOCK,m_bDockOutputVisible);
	theApp.WriteInt(APPREG_PLAYER_DOCK,m_bDockPlayerPosVisible);
}


int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWndEx::OnCreate(lpCreateStruct) == -1)
		return -1;

	// rWA }l[W visual X^Cݒ
	OnApplicationLook(theApp.m_nAppLook);

	// c[o[AXe[^Xo[ׂ͂ă{o[ƂȂ	
	if(!InitializeRibbon())
	{
		TRACE(_T("{̍쐬Ɏs܂B\n"));
		return -1;
	}
	if(!InitializeRibbon_Statusbar())
	{
		TRACE(_T("Xe[^Xo[Ɏs܂B\n"));
		return -1;
	}
	if(!InitializeRibbon_Docking())
	{
		TRACE(_T("hbNɎs܂B\n"));
		return -1;
	}

	m_bUIReady = TRUE;
	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if( !CFrameWndEx::PreCreateWindow(cs) )
		return FALSE;
	
	// ^CgɃt@C\Ȃ悤ɂ
	cs.style &= ~FWS_ADDTOTITLE;

	return TRUE;
}

// CMainFrame ff

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWndEx::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWndEx::Dump(dc);
}
#endif //_DEBUG


// CMainFrame bZ[W nh

void CMainFrame::OnApplicationLook(UINT id)
{
	CWaitCursor wait;

	theApp.m_nAppLook = id;

	switch (theApp.m_nAppLook)
	{
	case ID_VIEW_APPLOOK_WIN_2000:
		CMFCVisualManager::SetDefaultManager(RUNTIME_CLASS(CMFCVisualManager));
		break;
	case ID_VIEW_APPLOOK_OFF_XP:
		CMFCVisualManager::SetDefaultManager(RUNTIME_CLASS(CMFCVisualManagerOfficeXP));
		break;
	case ID_VIEW_APPLOOK_WIN_XP:
		CMFCVisualManagerWindows::m_b3DTabsXPTheme = TRUE;
		CMFCVisualManager::SetDefaultManager(RUNTIME_CLASS(CMFCVisualManagerWindows));
		break;
	case ID_VIEW_APPLOOK_OFF_2003:
		CMFCVisualManager::SetDefaultManager(RUNTIME_CLASS(CMFCVisualManagerOffice2003));
		CDockingManager::SetDockingMode(DT_SMART);
		break;
	case ID_VIEW_APPLOOK_VS_2005:
		CMFCVisualManager::SetDefaultManager(RUNTIME_CLASS(CMFCVisualManagerVS2005));
		CDockingManager::SetDockingMode(DT_SMART);
		break;
	default:
		switch (theApp.m_nAppLook)
		{
		case ID_VIEW_APPLOOK_OFF_2007_BLUE:
			CMFCVisualManagerOffice2007::SetStyle(CMFCVisualManagerOffice2007::Office2007_LunaBlue);
			break;
		case ID_VIEW_APPLOOK_OFF_2007_BLACK:
			CMFCVisualManagerOffice2007::SetStyle(CMFCVisualManagerOffice2007::Office2007_ObsidianBlack);
			break;
		case ID_VIEW_APPLOOK_OFF_2007_SILVER:
			CMFCVisualManagerOffice2007::SetStyle(CMFCVisualManagerOffice2007::Office2007_Silver);
			break;
		case ID_VIEW_APPLOOK_OFF_2007_AQUA:
			CMFCVisualManagerOffice2007::SetStyle(CMFCVisualManagerOffice2007::Office2007_Aqua);
			break;
		}
		CMFCVisualManager::SetDefaultManager(RUNTIME_CLASS(CMFCVisualManagerOffice2007));
		CDockingManager::SetDockingMode(DT_SMART);
	}

	RedrawWindow(NULL, NULL, RDW_ALLCHILDREN | RDW_INVALIDATE | RDW_UPDATENOW | RDW_FRAME | RDW_ERASE);
	theApp.WriteInt(APPREG_APPLICATION_LOOK, theApp.m_nAppLook);
}

void CMainFrame::OnUpdateApplicationLook(CCmdUI* pCmdUI)
{
	pCmdUI->SetRadio(theApp.m_nAppLook == pCmdUI->m_nID);
}

// {o[ɕ\Mxݒ肷
void CMainFrame::SetSignalLevel(float fSignalLevel)
{
	CMFCRibbonLabel *pLabel = m_RibbonItem.BonDriver.pRecieveLevel;
	if(pLabel&&m_bUIReady)
	{
		CString str;
		str.Format(_T("%.2f"),fSignalLevel);
		pLabel->SetText(str);
		pLabel->Redraw();
	}
}

// Xe[^Xo[ɃeLXg\
void CMainFrame::SetStatusBarText(LPCTSTR lpszText,int iPane)
{	
	CString *pStr = new CString(lpszText);
	switch(iPane)
	{
	case 0:
		this->PostMessage(m_uRibbonItemUpdate,ID_STATUSBAR_PANE1,(LPARAM)pStr);
		break;
	default:
		delete pStr;
	}
}

void CMainFrame::OnDestroy()
{
	m_bUIReady = FALSE;
	CBonTestDoc *pDoc = reinterpret_cast<CBonTestDoc*>(GetActiveDocument());
	pDoc->OnClose(TRUE);
	CFrameWndEx::OnDestroy();
}

void CMainFrame::SetTunerList(CStringArray *pTunerList)
{
	this->PostMessage(m_uRibbonItemUpdate,ID_RIBBON_TUNER,(LPARAM)pTunerList);
}

void CMainFrame::SetChannelList(CStringArray *pChannelList)
{
	this->PostMessage(m_uRibbonItemUpdate,ID_RIBBON_CHANNEL,(LPARAM)pChannelList);
}

void CMainFrame::SetServiceList(CStringArray *pServiceList)
{
	this->PostMessage(m_uRibbonItemUpdate,ID_RIBBON_SERVICE_NAME_LIST,(LPARAM)pServiceList);
}

int CMainFrame::GetTunerSelect()
{
	CMFCRibbonComboBox *pCombo = m_RibbonItem.BonDriver.pTuner;	
	if(pCombo&&m_bUIReady)
	{
		return pCombo->GetCurSel();
	}
	return -1;
}

int CMainFrame::GetChannelSelect()
{
	CMFCRibbonComboBox *pCombo = m_RibbonItem.BonDriver.pChannel;	
	if(pCombo&&m_bUIReady)
	{
		return pCombo->GetCurSel();
	}
	return -1;
}

int CMainFrame::GetServiceSelect()
{
	CMFCRibbonComboBox *pCombo = m_RibbonItem.DTV.pService;	
	if(pCombo&&m_bUIReady)
	{
		return pCombo->GetCurSel();
	}
	return -1;
}

LRESULT CMainFrame::WindowProc(UINT message, WPARAM wParam, LPARAM lParam)
{
	if(message==m_uRibbonItemUpdate)
	{
		CMFCRibbonComboBox *pCombo = NULL;
		CMFCRibbonStatusBarPane *pStatusbarPane = NULL;
		CStringArray *pStringArray = NULL;
		CString *pString = NULL;
		switch(wParam)
		{
		case ID_RIBBON_TUNER:
			{
				pCombo = m_RibbonItem.BonDriver.pTuner;
				pStringArray = (CStringArray*)lParam;
			}
			break;
		case ID_RIBBON_CHANNEL:
			{
				pCombo = m_RibbonItem.BonDriver.pChannel;
				pStringArray = (CStringArray*)lParam;
			}
			break;
		case ID_RIBBON_SERVICE_NAME_LIST:
			{
				pCombo = m_RibbonItem.DTV.pService;
				pStringArray = (CStringArray*)lParam;
			}
			break;		
		case ID_STATUSBAR_PANE1:
			{
				pStatusbarPane = (CMFCRibbonStatusBarPane*)m_wndStatusBar.GetElement(0);
				pString = (CString*)lParam;
			}
			break;
		}
		if(pCombo && pStringArray && m_bUIReady)
		{
			pCombo->RemoveAllItems();
			int iSelect = min(max(0,pCombo->GetCurSel()),pStringArray->GetCount()-1);
			for(int i=0;i<pStringArray->GetCount();i++)
			{
				CString tmp = pStringArray->GetAt(i);
				pCombo->AddItem(tmp);
			}
			pCombo->SelectItem(iSelect);			
		}
		if(pStatusbarPane && pString && m_bUIReady)
		{
			pStatusbarPane->SetText(*pString);
			m_wndStatusBar.RecalcLayout();
			pStatusbarPane->Redraw();
		}
		if(pStringArray) delete pStringArray;
		if(pString) delete pString;
	}
	return CFrameWndEx::WindowProc(message, wParam, lParam);
}

void CMainFrame::LogPrintf(LPCTSTR format,...)
{
	va_list args;
	va_start(args,format);
	m_dockOutput.LogPrintfV(format,args);
	va_end(args);	
}

bool CMainFrame::OnSendAllOption(SendOptionFlg eFlg,CDocument *pTargetDocument)
{
	CBonTestDoc *pDoc = reinterpret_cast<CBonTestDoc*>(GetActiveDocument());
	if(pTargetDocument) pDoc = reinterpret_cast<CBonTestDoc*>(pTargetDocument);
	if(pDoc)
	{
		if(eFlg & SendOption_Video){
			pDoc->OnVideoAspectRatioMode(m_eVideoAspectRatioMode);
			}
		if(eFlg & SendOption_Audio){
			pDoc->OnAudioVolume(m_bAudioOutputEnable,m_iAudioVolume);
			pDoc->OnAudioOutputMode(m_eAudioOutputMode);
		}
	}
	return true;
}

void CMainFrame::ReSendOnSize()
{
	RECT rcRect;
	this->GetWindowRect(&rcRect);
	this->OnSize(SIZE_RESTORED,rcRect.right-rcRect.left,rcRect.bottom-rcRect.top);
}

void CMainFrame::ShowRibbon()
{
	m_wndRibbonBar.ShowPane(TRUE,FALSE,TRUE);
}

void CMainFrame::HideRibbon()
{
	m_wndRibbonBar.ShowPane(FALSE,FALSE,TRUE);
}

void CMainFrame::OnAspectratioAuto()
{
	m_eVideoAspectRatioMode = VideoAspectRatioMode_Auto;
	OnSendAllOption(SendOption_Video);
}

void CMainFrame::OnAspectratio16_9()
{
	m_eVideoAspectRatioMode = VideoAspectRatioMode_16_9;
	OnSendAllOption(SendOption_Video);
}

void CMainFrame::OnAspectratio4_3()
{
	m_eVideoAspectRatioMode = VideoAspectRatioMode_4_3;
	OnSendAllOption(SendOption_Video);
}

void CMainFrame::OnAspectratioDisabled()
{
	m_eVideoAspectRatioMode = VideoAspectRatioMode_Disabled;
	OnSendAllOption(SendOption_Video);
}

void CMainFrame::OnUpdateAspectratioAuto(CCmdUI *pCmdUI)
{
	pCmdUI->SetRadio(m_eVideoAspectRatioMode == VideoAspectRatioMode_Auto);
}

void CMainFrame::OnUpdateAspectratio16_9(CCmdUI *pCmdUI)
{
	pCmdUI->SetRadio(m_eVideoAspectRatioMode == VideoAspectRatioMode_16_9);
}

void CMainFrame::OnUpdateAspectratio4_3(CCmdUI *pCmdUI)
{
	pCmdUI->SetRadio(m_eVideoAspectRatioMode == VideoAspectRatioMode_4_3);
}

void CMainFrame::OnUpdateAspectratioDisabled(CCmdUI *pCmdUI)
{
	pCmdUI->SetRadio(m_eVideoAspectRatioMode == VideoAspectRatioMode_Disabled);
}

void CMainFrame::OnAudioEnable()
{
	m_bAudioOutputEnable = !m_bAudioOutputEnable;
	OnSendAllOption(SendOption_Audio);
}

void CMainFrame::OnUpdateAudioEnable(CCmdUI *pCmdUI)
{
	if(m_RibbonItem.DTV.pAudioEnable)
	{
		if(m_bAudioOutputEnable)
		{
			m_RibbonItem.DTV.pAudioEnable->SetImageIndex(4,FALSE);
		} else {
			m_RibbonItem.DTV.pAudioEnable->SetImageIndex(5,FALSE);
		}
	}
}

void CMainFrame::OnAudioVolume()
{
	if(m_RibbonItem.DTV.pAudioSlider)
	{
		m_iAudioVolume = m_RibbonItem.DTV.pAudioSlider->GetPos();
		OnSendAllOption(SendOption_Audio);
	}
}

void CMainFrame::OnAudioOutputThrow()
{
	m_eAudioOutputMode = AudioOutputMode_Throw;
	OnSendAllOption(SendOption_Audio);
}

void CMainFrame::OnAudioOutputLeftOnly()
{
	m_eAudioOutputMode = AudioOutputMode_LeftOnly;
	OnSendAllOption(SendOption_Audio);
}

void CMainFrame::OnAudioOutputRightOnly()
{
	m_eAudioOutputMode = AudioOutputMode_RightOnly;
	OnSendAllOption(SendOption_Audio);
}

void CMainFrame::OnUpdateAudioOutputThrow(CCmdUI *pCmdUI)
{
	pCmdUI->SetRadio(m_eAudioOutputMode == AudioOutputMode_Throw);
}

void CMainFrame::OnUpdateAudioOutputLeftOnly(CCmdUI *pCmdUI)
{
	pCmdUI->SetRadio(m_eAudioOutputMode == AudioOutputMode_LeftOnly);
}

void CMainFrame::OnUpdateAudioOutputRightOnly(CCmdUI *pCmdUI)
{
	pCmdUI->SetRadio(m_eAudioOutputMode == AudioOutputMode_RightOnly);
}

void CMainFrame::OnDockOutput()
{
	m_bDockOutputVisible = !m_bDockOutputVisible;
	m_dockOutput.ShowPane(m_bDockOutputVisible ? SW_SHOW : SW_HIDE , FALSE , TRUE);
}

void CMainFrame::OnUpdateDockOutput(CCmdUI *pCmdUI)
{
	m_bDockOutputVisible = m_dockOutput.IsVisible();
	pCmdUI->SetCheck(m_bDockOutputVisible);
}

void CMainFrame::OnDockPlayerPos()
{
	m_bDockPlayerPosVisible = !m_bDockPlayerPosVisible;
	m_dockPlayerPos.ShowPane(m_bDockPlayerPosVisible ? SW_SHOW : SW_HIDE , FALSE , TRUE);
}

void CMainFrame::OnUpdateDockPlayerPos(CCmdUI *pCmdUI)
{
	m_bDockPlayerPosVisible = m_dockPlayerPos.IsVisible();
	pCmdUI->SetCheck(m_bDockPlayerPosVisible);
}
