//  MFC Tv \[X R[hł́AMFC Microsoft Office Fluent [U[ C^[tFCX 
// ("Fluent UI") ̎gp@܂B̃R[h́AMFC C++ Cu \tgEFA 
// Ă Microsoft Foundation Class t@Xъ֘AdqhLg
// ⊮邽߂̎QlƂĒ񋟂܂B
// Fluent UI 𕡐AgpA܂͔zz邽߂̃CZX͌ʂɗpӂĂ܂B
// Fluent UI CZX vȌڍׂɂẮAWeb TCg
// http://msdn.microsoft.com/officeui QƂĂB
//
// Copyright (C) Microsoft Corporation
// All rights reserved.

#include "stdafx.h"

#include "OutputWnd.h"
#include "Resource.h"
#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// COutputBar

COutputWnd::COutputWnd()
{
	// R\[r[̃tH[}bgݒ
}

COutputWnd::~COutputWnd()
{
}

BEGIN_MESSAGE_MAP(COutputWnd, CDockablePane)
	ON_WM_CREATE()
	ON_WM_SIZE()
END_MESSAGE_MAP()

// PsƂɕďo͂
int CLogCtrl::AddString(LPCTSTR lpszItem)
{
	CString tmp(lpszItem);
	do
	{
		CString line=tmp.SpanExcluding(_T("\r\n\0"));
		tmp = tmp.Mid(line.GetLength()).TrimLeft(_T("\r\n\0"));

		int iLastPos = GetWindowTextLength();
		SetSel(iLastPos, iLastPos);
		CListBox::AddString(line);

		while(GetCount() > (LOG_LIMIT - 1))
		{
			DeleteString(0);
		}
		int sel = GetCurSel();
		int top = GetTopIndex();
		if(top<=sel || sel==LB_ERR)
		{
			int line = GetCount(); 
			SetCurSel(line-1);
		}	
	} while(tmp.GetLength());
	
	return 0;
}

int COutputWnd::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CDockablePane::OnCreate(lpCreateStruct) == -1)
		return -1;

	m_Font.CreateStockObject(DEFAULT_GUI_FONT);

	CRect rectDummy;
	rectDummy.SetRectEmpty();

	// ^utEBhE̍쐬:
	if (!m_wndTabs.Create(CMFCTabCtrl::STYLE_FLAT, rectDummy, this, 1))
	{
		TRACE0("^uto̓EBhE쐬ł܂ł\n");
		return -1;      // 쐬łȂꍇ
	}

	// o̓yC̍쐬:
	const DWORD dwStyle = LBS_NOINTEGRALHEIGHT | WS_CHILD | WS_VISIBLE | WS_HSCROLL | WS_VSCROLL;
	if (!m_wndOutputLog.Create(dwStyle, rectDummy, &m_wndTabs, 2))
	{
		TRACE0("o̓EBhE쐬ł܂ł\n");
		return -1;      // 쐬łȂꍇ
	}

	m_wndOutputLog.SetFont(&m_Font);

	CString strTabName;
	BOOL bNameValid;

	// ꗗEBhE^uɊ蓖Ă܂:

	bNameValid = strTabName.LoadString(IDS_TABNAME_LOG);
	ASSERT(bNameValid);
	m_wndTabs.AddTab(&m_wndOutputLog, strTabName, (UINT)0);


	// eLXg͂܂
	SetInitText();

	return 0;
}

void COutputWnd::OnSize(UINT nType, int cx, int cy)
{
	CDockablePane::OnSize(nType, cx, cy);

	// ^u Rg[́ANCAg̈ŜJo[Kv܂:
	m_wndTabs.SetWindowPos (NULL, -1, -1, cx, cy, SWP_NOMOVE | SWP_NOACTIVATE | SWP_NOZORDER);
}

void COutputWnd::SetInitText()
{
	// OEBhE
}

void COutputWnd::LogPrintf(LPCTSTR format,...)
{
	va_list args;
	va_start(args,format);
	LogPrintfV(format,args);
	va_end(args);	
}

void COutputWnd::LogPrintfV(LPCTSTR format,va_list args)
{
	CString tmp;
	tmp.FormatV(format,args);
	m_wndOutputLog.AddString(tmp);
}

/////////////////////////////////////////////////////////////////////////////
// COutputList1

CLogCtrl::CLogCtrl()
{
}

CLogCtrl::~CLogCtrl()
{
}

BEGIN_MESSAGE_MAP(CLogCtrl, CRichEditCtrl)
	ON_WM_CONTEXTMENU()
	ON_COMMAND(ID_EDIT_COPY, OnEditCopy)
	ON_COMMAND(ID_EDIT_CLEAR, OnEditClear)
//	ON_COMMAND(ID_VIEW_OUTPUTWND, OnViewOutput)
	ON_WM_WINDOWPOSCHANGING()
END_MESSAGE_MAP()
/////////////////////////////////////////////////////////////////////////////
// COutputList bZ[W nh

void CLogCtrl::OnContextMenu(CWnd* /*pWnd*/, CPoint point)
{
	CMenu menu;
//	menu.LoadMenu(IDR_OUTPUT_POPUP);

	CMenu* pSumMenu = menu.GetSubMenu(0);

	if (AfxGetMainWnd()->IsKindOf(RUNTIME_CLASS(CMDIFrameWndEx)))
	{
		CMFCPopupMenu* pPopupMenu = new CMFCPopupMenu;

		if (!pPopupMenu->Create(this, point.x, point.y, (HMENU)pSumMenu->m_hMenu, FALSE, TRUE))
			return;

		((CMDIFrameWndEx*)AfxGetMainWnd())->OnShowPopupMenu(pPopupMenu);
		UpdateDialogControls(this, FALSE);
	}

	SetFocus();
}

void CLogCtrl::OnEditCopy()
{
	MessageBox(_T("o̓f[^Rs[܂"));
}

void CLogCtrl::OnEditClear()
{
	MessageBox(_T("o̓f[^NA܂"));
}

void CLogCtrl::OnViewOutput()
{
	CDockablePane* pParentBar = DYNAMIC_DOWNCAST(CDockablePane, GetOwner());
	CMDIFrameWndEx* pMainFrame = DYNAMIC_DOWNCAST(CMDIFrameWndEx, GetTopLevelFrame());

	if (pMainFrame != NULL && pParentBar != NULL)
	{
		pMainFrame->SetFocus();
		pMainFrame->ShowPane(pParentBar, FALSE, FALSE, FALSE);
		pMainFrame->RecalcLayout();

	}
}


