//  MFC Tv \[X R[hł́AMFC Microsoft Office Fluent [U[ C^[tFCX 
// ("Fluent UI") ̎gp@܂B̃R[h́AMFC C++ Cu \tgEFA 
// Ă Microsoft Foundation Class t@Xъ֘AdqhLg
// ⊮邽߂̎QlƂĒ񋟂܂B
// Fluent UI 𕡐AgpA܂͔zz邽߂̃CZX͌ʂɗpӂĂ܂B
// Fluent UI CZX vȌڍׂɂẮAWeb TCg
// http://msdn.microsoft.com/officeui QƂĂB
//
// Copyright (C) Microsoft Corporation
// All rights reserved.

// MainFrm.cpp : CMainFrame NX̎
// {֌WȂ肪Ȃ̂ŕށA
// \[Xɓ̃j[IDStringe[u쐬ĂAIDĝył

#include "stdafx.h"
#include "BonTestUI.h"

#include "MainFrm.h"
#include <memory>

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

//#define ENABLE_SEEKBAR

// CMainFrame

BOOL CMainFrame::InitializeRibbon()
{
	if(!m_wndRibbonBar.Create(this))
	{
		return FALSE;
	}
	if(!InitializeRibbon_MainButton())
	{
		return FALSE;
	}
	if(!InitializeRibbon_Home())
	{
		return FALSE;
	}
//	if(!InitializeRibbon_Record())
//	{
//		return FALSE;
//	}
	if(!InitializeRibbon_View())
	{
		return FALSE;
	}
	if(!InitializeRibbon_VisualStyle())
	{
		return FALSE;
	}
	if(!InitializeRibbon_Help())
	{
		return FALSE;
	}
	if(!InitializeRibbon_QuickAccessToolbar())
	{
		return FALSE;
	}
	return TRUE;
}

BOOL CMainFrame::InitializeRibbon_MainButton()
{
	BOOL bNameValid;
	CString strTemp;

	bNameValid = strTemp.LoadString(IDS_RIBBON_FILE);
	ASSERT(bNameValid);

	// plC[Wǂݍ
	m_PanelImages.SetImageSize(CSize(16, 16));
	m_PanelImages.Load(IDB_BUTTONS);

	// C{^
	m_MainButton.SetImage(IDB_MAIN);
	m_MainButton.SetText(_T("\nF"));
	m_MainButton.SetToolTipText(strTemp);

	m_wndRibbonBar.SetApplicationButton(&m_MainButton, CSize (45, 45));
	CMFCRibbonMainPanel* pMainPanel = m_wndRibbonBar.AddMainCategory(strTemp, IDB_FILESMALL, IDB_FILELARGE);

	bNameValid = strTemp.LoadString(IDS_RIBBON_NEW);
	ASSERT(bNameValid);
	pMainPanel->Add(new CMFCRibbonButton(ID_FILE_NEW, strTemp, 0, 0));
	bNameValid = strTemp.LoadString(IDS_RIBBON_OPEN);
	ASSERT(bNameValid);
	pMainPanel->Add(new CMFCRibbonButton(ID_FILE_OPEN, strTemp, 1, 1));
	
	bNameValid = strTemp.LoadString(IDS_RIBBON_BON_TS_ENGINE_RESET);
	ASSERT(bNameValid);
	pMainPanel->AddToBottom(new CMFCRibbonMainPanelButton(ID_DTV_BONTSENGINE_RESET, strTemp,-1));

	// ŋߎgt@C
	bNameValid = strTemp.LoadString(IDS_RIBBON_RECENT_DOCS);
	ASSERT(bNameValid);
	pMainPanel->AddRecentFilesList(strTemp);

	bNameValid = strTemp.LoadString(IDS_RIBBON_EXIT);
	ASSERT(bNameValid);
	pMainPanel->AddToBottom(new CMFCRibbonMainPanelButton(ID_APP_EXIT, strTemp, 15));

	return TRUE;
}

BOOL CMainFrame::InitializeRibbon_Home()
{
	BOOL bNameValid;
	CString strTemp;
	CMFCRibbonButton *pBtnTmp;

	// [z[] JeSǉ
	bNameValid = strTemp.LoadString(IDS_RIBBON_HOME);
	ASSERT(bNameValid);
	CMFCRibbonCategory* pCategoryHome = m_wndRibbonBar.AddCategory(strTemp, IDB_DTV, IDB_WRITELARGE);

	// [BonDriver] pl쐬Ēǉ
	bNameValid = strTemp.LoadString(IDS_RIBBON_BON_DRIVER);
	ASSERT(bNameValid);
	CMFCRibbonPanel* pPanelBonDriver = pCategoryHome->AddPanel(strTemp);

	bNameValid = strTemp.LoadString(ID_RIBBON_TUNER);
	ASSERT(bNameValid);
	m_RibbonItem.BonDriver.pTuner = new CMFCRibbonComboBox(ID_RIBBON_TUNER, FALSE, 100, strTemp);
	pPanelBonDriver->Add(m_RibbonItem.BonDriver.pTuner);

	bNameValid = strTemp.LoadString(ID_RIBBON_CHANNEL);
	ASSERT(bNameValid);
	m_RibbonItem.BonDriver.pChannel = new CMFCRibbonComboBox(ID_RIBBON_CHANNEL, FALSE, 100, strTemp);
	pPanelBonDriver->Add(m_RibbonItem.BonDriver.pChannel);

	std::auto_ptr<CMFCRibbonButtonsGroup> apLevelGroup(new CMFCRibbonButtonsGroup);
	bNameValid = strTemp.LoadString(IDS_RIBBON_RECIEVE_LEVEL);
	ASSERT(bNameValid);
	apLevelGroup->AddButton(new CMFCRibbonLabel(strTemp));
	m_RibbonItem.BonDriver.pRecieveLevel = new CMFCRibbonLabel(_T("00.00"));
	apLevelGroup->AddButton(m_RibbonItem.BonDriver.pRecieveLevel);
	bNameValid = strTemp.LoadString(IDS_RIBBON_RECIEVE_LEVEL_SCALE);
	ASSERT(bNameValid);
	apLevelGroup->AddButton(new CMFCRibbonLabel(strTemp));
	pPanelBonDriver->Add(apLevelGroup.get());
	apLevelGroup.release();

	// [] pl쐬Ēǉ
	bNameValid = strTemp.LoadString(IDS_RIBBON_DTV_VIEW);
	ASSERT(bNameValid);
	CMFCRibbonPanel* pPanelDtvViewer = pCategoryHome->AddPanel(strTemp, 0);

	/// T[rX ///	
	bNameValid = strTemp.LoadString(ID_RIBBON_SERVICE_NAME_LIST);
	ASSERT(bNameValid);
	m_RibbonItem.DTV.pService = new CMFCRibbonComboBox(ID_RIBBON_SERVICE_NAME_LIST, FALSE, 200,strTemp);
	pPanelDtvViewer->Add(m_RibbonItem.DTV.pService);

	pPanelDtvViewer->Add(new CMFCRibbonSeparator(TRUE));

	/// AXyNg(c[o[łĂǁA蓮쐬̎) ///
	std::auto_ptr<CMFCRibbonButtonsGroup> apVideoGroup(new CMFCRibbonButtonsGroup);
	// 
	bNameValid = strTemp.LoadString(ID_ASPECTRATIO_AUTO);
	ASSERT(bNameValid);
	pBtnTmp = new CMFCRibbonButton(ID_ASPECTRATIO_AUTO,NULL,0);
	pBtnTmp->SetToolTipText(strTemp);
	apVideoGroup->AddButton(pBtnTmp);
	// 16:9
	bNameValid = strTemp.LoadString(ID_ASPECTRATIO_16_9);
	ASSERT(bNameValid);
	pBtnTmp = new CMFCRibbonButton(ID_ASPECTRATIO_16_9,NULL,1);
	pBtnTmp->SetToolTipText(strTemp);
	apVideoGroup->AddButton(pBtnTmp);
	// 4:3
	bNameValid = strTemp.LoadString(ID_ASPECTRATIO_4_3);
	ASSERT(bNameValid);
	pBtnTmp = new CMFCRibbonButton(ID_ASPECTRATIO_4_3,NULL,2);
	pBtnTmp->SetToolTipText(strTemp);
	apVideoGroup->AddButton(pBtnTmp);
	// 
	bNameValid = strTemp.LoadString(ID_ASPECTRATIO_DISABLED);
	ASSERT(bNameValid);
	pBtnTmp = new CMFCRibbonButton(ID_ASPECTRATIO_DISABLED,NULL,3);
	pBtnTmp->SetToolTipText(strTemp);
	apVideoGroup->AddButton(pBtnTmp);

	pPanelDtvViewer->Add(apVideoGroup.get());
	apVideoGroup.release();
	/// o ///
	std::auto_ptr<CMFCRibbonButtonsGroup> apAudioGroup(new CMFCRibbonButtonsGroup);
	// o͐؂ւ
	bNameValid = strTemp.LoadString(ID_AUDIO_ENABLE);
	ASSERT(bNameValid);
	m_RibbonItem.DTV.pAudioEnable = new CMFCRibbonButton(ID_AUDIO_ENABLE,NULL,4);
	m_RibbonItem.DTV.pAudioEnable->SetToolTipText(strTemp);
	apAudioGroup->AddButton(m_RibbonItem.DTV.pAudioEnable);
	// {[
	bNameValid = strTemp.LoadString(ID_RIBBON_AUDIO_VOLUME);
	ASSERT(bNameValid);
	m_RibbonItem.DTV.pAudioSlider = new CMFCRibbonSlider(ID_DTV_AUDIO_VOLUME,100);
	m_RibbonItem.DTV.pAudioSlider->SetToolTipText(strTemp);
	m_RibbonItem.DTV.pAudioSlider->SetZoomButtons(TRUE);
	m_RibbonItem.DTV.pAudioSlider->SetRange(m_iAudioVolumeMin,m_iAudioVolumeMax);
	m_RibbonItem.DTV.pAudioSlider->SetPos(m_iAudioVolume);
	m_RibbonItem.DTV.pAudioSlider->SetZoomIncrement(50);
	apAudioGroup->AddButton(m_RibbonItem.DTV.pAudioSlider);

	pPanelDtvViewer->Add(apAudioGroup.get());
	apAudioGroup.release();
	/// o̓`lI ///
	std::auto_ptr<CMFCRibbonButtonsGroup> apAudioGroup2(new CMFCRibbonButtonsGroup);
	// L+RX[
	bNameValid = strTemp.LoadString(ID_AUDIO_THROW);
	ASSERT(bNameValid);
	pBtnTmp = new CMFCRibbonButton(ID_AUDIO_THROW,NULL,6);
	pBtnTmp->SetToolTipText(strTemp);
	apAudioGroup2->AddButton(pBtnTmp);
	// L
	bNameValid = strTemp.LoadString(ID_AUDIO_LEFT_ONLY);
	ASSERT(bNameValid);
	pBtnTmp = new CMFCRibbonButton(ID_AUDIO_LEFT_ONLY,NULL,7);
	pBtnTmp->SetToolTipText(strTemp);
	apAudioGroup2->AddButton(pBtnTmp);
	// R
	bNameValid = strTemp.LoadString(ID_AUDIO_RIGHT_ONLY);
	ASSERT(bNameValid);
	pBtnTmp = new CMFCRibbonButton(ID_AUDIO_RIGHT_ONLY,NULL,8);
	pBtnTmp->SetToolTipText(strTemp);
	apAudioGroup2->AddButton(pBtnTmp);

	pPanelDtvViewer->Add(apAudioGroup2.get());
	apAudioGroup2.release();

	pPanelDtvViewer->EnableLaunchButton(ID_DTV_VIDEO_DECODER);

	return TRUE;
}

BOOL CMainFrame::InitializeRibbon_Record()
{
	BOOL bNameValid;
	CString strTemp;
	CMFCRibbonButton *pBtnTmp;

	// [^] JeSǉ
	bNameValid = strTemp.LoadString(IDS_RIBBON_RECORD);
	ASSERT(bNameValid);
	CMFCRibbonCategory* pCategoryRecord = m_wndRibbonBar.AddCategory(strTemp, IDB_WRITESMALL, IDB_WRITELARGE);

	// [^] pl쐬Ēǉ
	bNameValid = strTemp.LoadString(IDS_RIBBON_RECORD);
	ASSERT(bNameValid);
	CMFCRibbonPanel* pPanelRecord = pCategoryRecord->AddPanel(strTemp);

	pPanelRecord->Add(new CMFCRibbonLabel(_T(""),TRUE));


	return true;
}

BOOL CMainFrame::InitializeRibbon_View()
{
	BOOL bNameValid;
	CString strTemp;
	CMFCRibbonButton *pBtnTmp;

	// [\] JeSǉ
	bNameValid = strTemp.LoadString(IDS_RIBBON_VIEW);
	ASSERT(bNameValid);
	CMFCRibbonCategory* pCategoryView = m_wndRibbonBar.AddCategory(strTemp, IDB_VIEW, IDB_WRITELARGE);

	// [\] pl쐬Ēǉ
	bNameValid = strTemp.LoadString(IDS_RIBBON_VIEW);
	ASSERT(bNameValid);
	CMFCRibbonPanel* pPanelView = pCategoryView->AddPanel(strTemp);

	bNameValid = strTemp.LoadString(ID_VIEW_STATUS_BAR);
	ASSERT(bNameValid);
	pBtnTmp = new CMFCRibbonButton(ID_VIEW_STATUS_BAR,_T("Xe[^Xo["),0);
	pBtnTmp->SetToolTipText(strTemp);
	pPanelView->Add(pBtnTmp);

	bNameValid = strTemp.LoadString(ID_DOCK_OUTPUT);
	ASSERT(bNameValid);
	pBtnTmp = new CMFCRibbonButton(ID_DOCK_OUTPUT,_T("o"),1);
	pBtnTmp->SetToolTipText(strTemp);
	pPanelView->Add(pBtnTmp);

#ifdef ENABLE_SEEKBAR
	// {^łĂȂ
	pPanelView->Add(new CMFCRibbonButton(ID_DOCK_PLAYERPOS,_T("V[No[")));
#endif

	// {^܂肢oł͂Ȃ
	pPanelView->Add(new CMFCRibbonButton(ID_DTV_VIDEO_DECODER,_T("fR[_"),2));
	pPanelView->Add(new CMFCRibbonButton(ID_DTV_VIDEO_RENDERER,_T("_"),3));	

	return true;
}

BOOL CMainFrame::InitializeRibbon_VisualStyle()
{
	BOOL bNameValid;
	CString strTemp;

	bNameValid = strTemp.LoadString(IDS_RIBBON_STYLE);
	ASSERT(bNameValid);
	CMFCRibbonButton* pVisualStyleButton = new CMFCRibbonButton(-1, strTemp, -1, -1);

	pVisualStyleButton->SetMenu(IDR_THEME_MENU, FALSE /* ̃R}h܂*/, TRUE /* E*/);

	bNameValid = strTemp.LoadString(IDS_RIBBON_STYLE_TIP);
	ASSERT(bNameValid);
	pVisualStyleButton->SetToolTipText(strTemp);
	bNameValid = strTemp.LoadString(IDS_RIBBON_STYLE_DESC);
	ASSERT(bNameValid);
	pVisualStyleButton->SetDescription(strTemp);
	m_wndRibbonBar.AddToTabs(pVisualStyleButton);

	return TRUE;
}

BOOL CMainFrame::InitializeRibbon_Help()
{
	m_wndRibbonBar.AddToTabs(new CMFCRibbonButton(ID_APP_ABOUT, _T("\nA"), m_PanelImages.ExtractIcon (0)));
	return TRUE;
}

BOOL CMainFrame::InitializeRibbon_QuickAccessToolbar()
{
	CString strTemp;

	CList<UINT, UINT> lstQATCmds;

//	lstQATCmds.AddTail(ID_FILE_NEW);
//	lstQATCmds.AddTail(ID_FILE_OPEN);
//	lstQATCmds.AddTail(ID_FILE_SAVE);
//	lstQATCmds.AddTail(ID_FILE_PRINT_DIRECT);

	// ǉ
	m_wndRibbonBar.SetQuickAccessCommands(lstQATCmds);

	return TRUE;
}

BOOL CMainFrame::InitializeRibbon_Statusbar()
{
	BOOL bNameValid;
	if(!m_wndStatusBar.Create(this))
	{
		return FALSE;
	}

	CString strTitlePane1 = L"";
	m_wndStatusBar.AddElement(new CMFCRibbonStatusBarPane(ID_STATUSBAR_PANE1, strTitlePane1, TRUE), strTitlePane1);

	return TRUE;
}

BOOL CMainFrame::InitializeRibbon_Docking()
{
	// Visual Studio 2005 X^C̃hbLO EBhELɂ܂
	CDockingManager::SetDockingMode(DT_SMART);
	// Visual Studio 2005 X^C̃hbLO EBhE̎\Lɂ܂
	EnableAutoHidePanes(CBRS_ALIGN_ANY);

	BOOL bNameValid;
	CString strTemp;
	bNameValid = strTemp.LoadString(ID_DOCK_OUTPUT_TITLE);
	ASSERT(bNameValid);
	if (!m_dockOutput.Create (strTemp, this, CRect (0, 0, 300, 100),
		TRUE , ID_DOCK_OUTPUT,
		WS_CHILD | WS_CLIPSIBLINGS | WS_CLIPCHILDREN | CBRS_BOTTOM | CBRS_FLOAT_MULTI))
	{
		return FALSE;
	}

	m_dockOutput.EnableDocking(CBRS_ALIGN_ANY);
	m_dockOutput.ShowPane(m_bDockOutputVisible ? SW_SHOW : SW_HIDE , FALSE , TRUE);
	DockPane(&m_dockOutput);

#ifdef ENABLE_SEEKBAR
	if (!m_dockPlayerPos.Create (_T("V[No["), this, CRect (0, 0, 300, 50),
		TRUE , ID_DOCK_PLAYERPOS,
		WS_CHILD | WS_CLIPSIBLINGS | WS_CLIPCHILDREN | CBRS_BOTTOM | CBRS_FLOAT_MULTI))
	{
		return FALSE;
	}

	m_dockPlayerPos.EnableDocking(CBRS_ALIGN_ANY);
	m_dockPlayerPos.ShowPane(m_bDockPlayerPosVisible ? SW_SHOW : SW_HIDE , FALSE , TRUE);
	DockPane(&m_dockPlayerPos);
#endif
	return TRUE;
}